Attribute VB_Name = "SoundSystem"
Option Explicit
Public Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Public Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
'Constants for PlayWaveAdv sub
Public Const SND_SYNC = &H0            '  play synchronously (default)
Public Const SND_ASYNC = &H1           '  play asynchronously
Public Const SND_NODEFAULT = &H2       '  silence not default, if sound not found
Public Const SND_MEMORY = &H4          '  lpszSoundName points to a memory file
Public Const SND_ALIAS = &H10000       '  name is a WIN.INI [sounds] entry
Public Const SND_FILENAME = &H20000    '  name is a file name
Public Const SND_RESOURCE = &H40004    '  name is a resource name or atom
Public Const SND_ALIAS_ID = &H110000   '  name is a WIN.INI [sounds] entry identifier
Public Const SND_ALIAS_START = 0       '  must be > 4096 to keep strings in same section of resource file
Public Const SND_LOOP = &H8            '  loop the sound until next sndPlaySound
Public Const SND_NOSTOP = &H10         '  don't stop any currently playing sound
Public Const SND_VALID = &H1F          '  valid flags          / ;Internal /
Public Const SND_NOWAIT = &H2000       '  don't wait if the driver is busy
Public Const SND_VALIDFLAGS = &H17201F '  Set of valid flag bits.  Anything outside
                                       '  this range will raise an error
Public Const SND_RESERVED = &HFF000000 '  In particular these flags are reserved
Public Const SND_TYPE_MASK = &H170007

Public Function HasSoundCard() As Boolean
  If waveOutGetNumDevs > 0 Then
    HasSoundCard = True
  Else
    HasSoundCard = False
  End If
End Function

Public Sub PlayMidi(M$)
    StopMidi
    Dim i As Long, RS As String, cb As Long
    RS = Space$(128)
    i = mciSendString("open sequencer!" & M$ & " alias midi", RS, 128, cb)
    If i Then MsgBox "Error!"
    i = mciSendString("play midi", RS, 128, cb)
End Sub

Public Sub PlayRESMidi(RM$)  'Still experimental
'   Dim bSound() As Byte
'   bSound = LoadResData(RM$, "MIDI")
'   Dim aSound As String
'   aSound = Space$(UBound(bSound) + 1)
'   CopyMemory ByVal aSound, bSound(0), Len(aSound)
'   PlayMidi aSound
End Sub

Public Sub StopMidi()
 Dim i As Long, RS As String, cb As Long
    RS = Space$(128)
    i = mciSendString("stop midi", RS, 128, cb)
    i = mciSendString("close midi", RS, 128, cb)
End Sub

Public Sub PlayWave(W$)
    StopWave
    Dim i As Long, RS As String, cb As Long
    RS = Space$(128)
    i = mciSendString("open waveaudio!" & W$ & " alias sound", RS, 128, cb)
    If i Then MsgBox "PlayWave Error!"
    i = mciSendString("play sound", RS, 128, cb)
End Sub

Public Sub PlayWaveAdv(AW$, FLG&)
    StopWave
    Dim i As Long
    i = sndPlaySound(AW$, FLG&)
    If i = 0 Then MsgBox "PlayWaveAdv Error!"
End Sub

Public Sub PlayRESWave(RW$)
   Dim bSound() As Byte
   bSound = LoadResData(RW$, "WAVE")
   Dim aSound As String
   aSound = Space$(UBound(bSound) + 1)
   CopyMemory ByVal aSound, bSound(0), Len(aSound)
   PlayWaveAdv aSound, SND_ASYNC Or SND_MEMORY
End Sub

Public Sub StopWave()
    Dim i As Long, RS As String, cb As Long
    RS = Space$(128)
    i = mciSendString("stop sound", RS, 128, cb)
    i = mciSendString("close sound", RS, 128, cb)
End Sub

Public Sub StopAllSound()
    Dim i As Long, RS As String, cb As Long
    RS = Space$(128)
    i = mciSendString("stop sound", RS, 128, cb)
    i = mciSendString("stop midi", RS, 128, cb)
    i = mciSendString("close sound", RS, 128, cb)
    i = mciSendString("close midi", RS, 128, cb)
End Sub
